<?php
  

  // Just a generic class to pass to functions to differenciate from other arguments
  class Object {
    function Object( $id ){
      $this->id = $id;
    }
  }

  class XmlClient {
    function XmlClient(){
      $this->port = "6884";
      $this->host = "localhost";
      $this->path = "/process.cgi";
      $this->connectionId = 0;
      $this->pluginId = "";
	  $this->pluginConfigId = "";
      $this->downloadManagerId = "";
      $this->torrentManagerId = "";
      $this->requestID = 0;
      $this->init();
    }
    
    // Set up a connection id
    function init(){
      $arr = $this->call("getSingleton");
      $this->connectionId = trim( $arr->_connection_id );
      $this->pluginId = trim( $arr->_object_id );
    }
    
    // Start (restart)
    function restart( $id ){
      // echo "restart( $id )\n";
      $this->call( "restart", $id );
    }
    
    // Force start
    function forceStart( $id ){
      $this->call( "setForceStart", $id, array( "true" ) );
    }
    
    // Move up
    function moveUp( $id ){
      $this->call( "moveUp", $id );
    }
    
    // Move down
    function moveDown( $id ){
      $this->call( "moveDown", $id );
    }
    
    // Stop
    function stop( $id ){
      $this->call( "stop", $id );
    }
    
    // Remove
    function remove( $id ){
      $this->call( "remove", $id );
    }
    
	function downspeed($id){
		$arr = $this->call("getPluginconfig", $this->pluginId );
		$this->pluginConfigId = $arr->_object_id;
		print_r( $this->call( "setParameter[String,int]", $this->pluginConfigId, array("Max Download Speed KBs",15)) );
		print_r( $this->call( "setParameter[String,int]", $this->pluginConfigId, array("Max Upload Speed KBs",15)) );
    }

	function upspeed($id){
		$arr = $this->call("getPluginconfig", $this->pluginId );
		$this->pluginConfigId = $arr->_object_id;
		print_r( $this->call( "setParameter[String,int]", $this->pluginConfigId, array("Max Download Speed KBs",0)) );
		print_r( $this->call( "setParameter[String,int]", $this->pluginConfigId, array("Max Upload Speed KBs",14)) );
    }

	/*function getdownspeed(){
      $this->call( "getIntParameter", , array("CORE_PARAM_INT_MAX_UPLOAD_SPEED_KBYTES_PER_SEC"));
	  $this->call( "save", $id);
    }*/

	// Upload
    function upload(){
      
      // Get file contents
      $fp  = fopen( $_FILES["file"]["tmp_name"], "r" );
      $buf = fread( $fp, filesize( $_FILES["file"]["tmp_name"] ) );
      fclose( $fp );
      
      // Create a torrent from the encoded data in the torrent file
      // TorrentManager.createFromBEncodedData
      return $this->createFromBEncodedData( bin2hex( $buf ) );
    }
    
    // Create torrent from data
    function createFromBEncodedData( $data ){
      
      // Get torrent manager
      $this->getTorrentManager();
      
      // Create torrent
      $arr = $this->call( "createFromBEncodedData[byte[]]", $this->torrentManagerId, array( $data ) );
      $torrent = new Object( $arr->_object_id );

      // Add download
      return $this->addDownload( $torrent );

    }
    
    
    // Add download
    function addDownload( $id ){
      $this->getDownloadManager();
      return $this->call("addDownload[Torrent]", $this->downloadManagerId, array( $id ) );
    }

    // Get downloads
    function getDownloads(){
      $this->getDownloadManager();
      return $this->call("getDownloads", 0 ); // Huh?! Why does this work? $this->downloadManagerId );
    }    
    
    // Get download manager
    function getDownloadManager(){
      $arr = $this->call("getDownloadManager", $this->pluginId );
      $this->downloadManagerId = $arr->_object_id;
    }
    
    // Get torrent manager
    function getTorrentManager(){
      $arr = $this->call("getTorrentManager", $this->pluginId );
      $this->torrentManagerId = $arr->_object_id;
    }

    // Call the web service
    function call( $method, $objectId="", $params=array() ){
      $xml = "";
      // Wrap up in a cuddly <request> block, adding bits
      if( $objectId && $this->connectionId ){ 
        $xml = "  <OBJECT>\n    <_object_id>$objectId</_object_id>\n  </OBJECT>\n  <CONNECTION_ID>".$this->connectionId."</CONNECTION_ID>\n";
      }
      $xml = "  <METHOD>$method</METHOD>\n$xml  <REQUEST_ID>".time().str_pad( $this->requestID, 4, "0", STR_PAD_LEFT )."</REQUEST_ID>\n";
      if( sizeof( $params ) > 0 ){
        $xml .= "  <PARAMS>";
	foreach( $params as $key => $value ){
	  if( is_object( $value ) ){
	    $xml .= "    <ENTRY><OBJECT><_object_id>".$value->id."</_object_id></OBJECT></ENTRY>\n";
	  }else{
            $xml .= "    <ENTRY>$value</ENTRY>\n";
	  }
        }
	$xml .= "</PARAMS>\n";
      }
      $xml = "<REQUEST>\n$xml</REQUEST>";
       //echo $xml;
      $this->requestID++;
      
      // echo htmlentities( $xml );
      
      // post to service
      return simplexml_load_string( $this->postData( $xml ) );
      
    }
    
    // Post XML data to specified service
    function postData( $data ){
      
      $remotepath = $this->path;
      $port       = $this->port;
      $host       = $this->host;
      
      // Generate the request header
      $reqheader =
      "POST $remotepath HTTP/1.1\r\n".
      "Host: $host:$port\r\n".
      "Content-Length: ".strlen( $data )."\r\n\r\n$data";
       
      // Open the connection to the host
      $socket = @fsockopen( $host, $port, $errno, $errstr );
      if (!$socket){
        $result["errno"] = $errno;
        $result["errstr"] = $errstr;
        echo "No socket created. Error $errno: $errstr\nExiting.\n";
        exit;
      }
      
      // Post data
      fputs( $socket, $reqheader );
      
      // Read data back
      $return = "";
      $start = false;
      while (!feof($socket)){
        $line = fgets($socket, 4096);
        if( strstr( $line, "<?xml" ) ) $start = true;
        if( $start ) $return .= $line;
      }
      fclose( $socket );
      // echo htmlentities( "$data\n$return\n" );
      
      // Return xml data
      return $return;
    }
  }

?>